# Serveur informatique
## Introduction

L'étape essentielle avant d'avoir à configurer et sécuriser un serveur est bien de "posséder" un serveur !
Bien entendu cela semble logique, mais c'est tout un monde qui s'ouvre à qui se penche sur la question.

Première étape : **Qu'est ce qu'un serveur informatique ?**
!!! quote "Définition"
    *Un serveur informatique est un dispositif informatique qui offre des services à un ou plusieurs clients.*  
    Wikipédia - 2021

Pour faire simple (les puristes me pardonneront je l'espère, ils auront compris que la vulgarisation sur ce site est assez vulgaire justement) : il s'agit d'**un ordinateur constamment fonctionnel et accessible sur internet**.
Et c'est bien pratique, puisqu'un ordinateur on peut y faire tourner des applications, lui faire réaliser des calculs, stocker des fichiers etc...

L'avantage avec un serveur étant sa haute disponibilité et son accessibilité : on peut y accéder **tout le temps et partout**, on est pas obligé d'être derrière un écran pour lancer des longs calculs et surtout on peut y héberger un site web, des bases de données etc...

!!! info
    Il est important de noter que je n'ai pas testé tous les serveurs existants ! Je ne parlerai que de deux gros "types" de serveur assez généralistes : les **VPS** et les **serveurs personnels** (Raspberry Pi, vieux ordinateurs etc...) ce qui permettra déjà d'avoir une bonne vision du principe.  
    Je parlerai donc en mon expérience et les avantages/inconvénients tirés de cette expérience.

## Quelle necessité ?
Et oui la fameuse question, souvent fâcheuse si vous êtes comme moi et que vous n'en savez rien. Vous êtes juste curieux et n'avez pas envie de mettre toutes vos économies dans des tests.

Il va donc falloir, avant de se mettre à penser "matériel/technique" penser au but de ce serveur :  

### **L'objectif principal**

   - Stockage de fichier ?
   - Hébergement de site internet ?
   - Lancement de gros processus de calcul ?

Chacun de ces objectifs (qui peuvent être mutualisés bien entendu) demande des ressources particulières :

- Stockage de fichier = **disque dur conséquent**
- Hébergement de site internet = **débit internet adapté**
- Lancement de gros processus de calcul = **processeur important**

Une fois que cette partie est définie (plus ou moins), on peut donc s'attaquer à la partie matériel et technique du serveur.  
Pour un petit curieux comme moi l'intérêt était de pouvoir obtenir un service à très faible coût mais permettant de réaliser pas mal d'opération. Mon but premier étant d'héberger mon [site internet](https://adriencharbonneau.fr). Mais aussi d'héberger différents autres sites et applications intéressantes (forum/dépôt git/documentation/service cloud etc...).  
Deux solutions s'offraient à moi :

### **Le matériel**

   - Créer moi-même un petit serveur permettant de réaliser mon objectif (Raspberry Pi / vieil ordinateur)
   - Utiliser un serveur mis à disposition en ligne (VPS)

Chacun ayant des avantages par rapport à l'autre le choix est difficile de prime abord, mais en réalité, le rapport qualité prix d'un VPS est largement acceptable face à l'achat d'un Raspberry Pi (ou d'un ordinateur qu'il soit vieux ou récent). En effet le Raspberry Pi dépend de la connexion internet de votre fournisseur, du temps passé dessus à la configurer correctement etc...  

Bref comme vous l'avez compris j'ai pris la solution **VPS** (mais je possède aussi un Raspberry Pi en serveur, ce qui me permettra de parler des deux).
